diff --git a/src/backend/tcop/utility.c b/src/backend/tcop/utility.c
index a95eff1..8fd5ee8 100644
--- a/src/backend/tcop/utility.c
+++ b/src/backend/tcop/utility.c
@@ -1898,7 +1898,14 @@ CreateCommandTag(Node *parsetree)
 	{
 			/* raw plannable queries */
 		case T_InsertStmt:
-			tag = "INSERT";
+			{
+				InsertStmt *stmt = (InsertStmt *) parsetree;
+
+				tag = "INSERT";
+				if (stmt->onConflictClause &&
+					stmt->onConflictClause->action == ONCONFLICT_UPDATE)
+					tag = "UPSERT";
+			}
 			break;
 
 		case T_DeleteStmt:
